BFD in Demand Mode over a Point-to-Point MPLS LSP
Internet-Draft draft-mirsky-bfd-mpls-demand-12
Greg Mirsky
Ericsson
gregimirsky@gmail.com
2022
Routing
BFD Working Group
Internet-Draft
BFD
Demand mode
LSP
This document describes procedures for using Bidirectional Forwarding Detection (BFD) in Demand mode to detect data plane failures in Multiprotocol Label Switching (MPLS) point-to-point Label Switched Paths.
Introduction
[RFC5884] defined use of the Asynchronous method of Bidirectional Detection (BFD) [RFC5880] to monitor and detect failures in the data path of a Multiprotocol Label Switching (MPLS) Label Switched Path (LSP). Use of the Demand mode, also specified in [RFC5880], has not been defined so far. This document describes procedures for using the Demand mode of BFD protocol to detect data plane failures in MPLS point-to-point (p2p) LSPs.
Acronyms
MPLS: Multiprotocol Label Switching
LSP: Label Switched Path
LER: Label switching Edge Router
BFD: Bidirectional Forwarding Detection
p2p: Point-to-Point
Use of the BFD Demand Mode
[RFC5880] defines that the Demand mode may be:
- asymmetric, i.e. used in one direction of a BFD session;
- switched to and from without bringing BFD session to Down state through using a Poll Sequence.
For the case of BFD over MPLS LSP, ingress Label switching Edge Router (LER) usually acts as Active BFD peer and egress LER acts as Passive BFD peer. The Active peer bootstraps the BFD session by using LSP ping. If the BFD session is configured to use the Demand mode, once the BFD session is in Up state the ingress LER switches to the Demand mode as defined in Section 6.6 [RFC5880]. The egress LER also follows procedures defined in Section 6.6 [RFC5880] and ceases further transmission of periodic BFD control packets to the ingress LER.
In this state BFD peers remain as long as the egress LER is in Up state. The ingress LER can periodically check continuity of a bidirectional path between the ingress and egress LERs by using the Poll Sequence, as described in Section 6.6 [RFC5880]. An implementation that supports using the Poll Sequence as the mechanism for bidirectional path continuity check must control the interval between consecutive Poll Sequences. The default value could be selected as 1 second.
If the Detection timer at the egress LER expires, the BFD system on the egress LER sends BFD Control packet to the ingress LER with the Poll (P) bit set, Status (Sta) field set to the Down (1) value, and the Diagnostic (Diag) field set to Control Detection Time Expired (1) value. The egress LER periodically transmits these Control packets to the ingress LER until either it receives the valid for this BFD session control packet with the Final (F) bit set from the ingress LER or the defect condition clears and the BFD session state reaches Up state at the egress LER. An implementation that supports this specification provides control of the interval between consecutive Poll messages signaling the expiration of the Detection timer. The default value of the interval can be selected as 1 second.
The ingress LER transmits BFD Control packets over the MPLS LSP with the Demand (D) flag set at negotiated interval per [RFC5880], the greater of bfd.DesiredMinTxInterval and bfd.RemoteMinRxInterval, until it receives the valid BFD packet from the egress LER with the Poll (P) bit and the Diagnostic (Diag) field value Control Detection Time Expired. Reception of such BFD control packet by the ingress LER indicates that the monitored LSP has a failure. Thus sending a BFD control packet with the Final flag set to acknowledge failure indication over the monitored LSP is likely to fail. Instead, the ingress LER transmits the BFD Control packet to the egress LER over the IP network with:
- destination IP address is set to the destination IP address of the LSP Ping Echo request message [RFC8029];
- destination UDP port set to 4784 [RFC5883];
- Final (F) flag in BFD control packet is set;
- Demand (D) flag in BFD control packet is cleared.
The ingress LER changes the state of the BFD session to Down and changes rate of BFD Control packets transmission to one packet per second. The ingress LER in Down mode changes to Asynchronous mode until the BFD session comes to Up state once again. Then the ingress LER switches to the Demand mode.
The Applicability of BFD for Multipoint Networks
[RFC8562] and [RFC8563] define the use of BFD in multipoint networks. This specification analyzes the case of p2p LSP. In that scenario, the ingress of the LSP acts as the MultipointHead, and the egress - as MultipointTail. The BFD state machines for MultipointHead, MultipointClient, and MultipointTail don't use the three-way handshakes for session establishment and teardown. As a result, the Init state is absent, and the session transitions to the Up state once the BFD session is administratively enabled. Hence, a BFD session over a p2p LSP, using principles of [RFC8562] or [RFC8563], can be established faster if the MultipointTail has been provisioned with the value of My Discriminator used by the MultipointHead for that BFD session. That value can be provided to the MultipointTail using different mechanisms, e.g., an extension to IGP. Description of mechanism to provide the value of My Discriminator used by the MultipointHead for the particular BFD session is outside the scope of this specification.
Unsolicited notification of the detected failure by the MultipointTail to the MultipointClient performs as described in Section 3 for the case after the ingress BFD system switches the remote peer into the Demand mode.
IANA Considerations
This document doesn't require any IANA action. This section can be removed before the publication of the document.
Security Considerations
This document does not introduce new security aspects but inherits all security considerations from [RFC5880], [RFC5884], [RFC7726], [RFC8029], [RFC6425], [RFC8562], and [RFC8563]
Acknowledgements
The author expresses his genuine appreciation of the extensive technical comments and the discussion with Jeffrey Haas that helped to clarify and properly position this document relative to the existing BFD specifications.
Normative References
[RFC5884]
[RFC5880]
[RFC8029]
[RFC5883]
[RFC8562]
[RFC8563]
[RFC7726]
[RFC6425]